<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
 * +-----------------------------------------------------------------------------+
 * | X-Cart Software license agreement                                           |
 * | Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
 * | All rights reserved.                                                        |
 * +-----------------------------------------------------------------------------+
 * | PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
 * | FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
 * | AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
 * |                                                                             |
 * | THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
 * | SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
 * | (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
 * | FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
 * | THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
 * | LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
 * | INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
 * | (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
 * | LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
 * | NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
 * | PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
 * | THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
 * | SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
 * | GRANTED BY THIS AGREEMENT.                                                  |
 * +-----------------------------------------------------------------------------+
 * \*****************************************************************************/

/**
 * Configuration options processing.
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    $Id$
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

namespace XC\PaypalCheckout;

if (!defined('XCART_START')) {
    header("Location: ../");
    die("Access denied");
}

/** @var string $REQUEST_METHOD */
/** @var string $option */
if ($REQUEST_METHOD == 'GET' && $option === 'Paypal_Checkout') {
    if (!empty($configuration)) {
        $configuration = func_paypal_checkout_request_webhooks($configuration);
    }

    x_session_register('paypal_checkout_signin_token');
    if (empty($maid) || empty($appt) || empty($t) || $t !== $paypal_checkout_signin_token) {
        Tabs::generateData();

    } elseif (CallbackHandler::savePaypalTokens_n_sendRestKeys($maid, $appt)) {
        x_session_unregister('paypal_checkout_signin_token');
        func_header_location(Tools::BASE_PAYPAL_CHECKOUT_URL . '/smb');
    } else {
        // Some Errors Were In The Above FunCation
        /** @var string $current_location */
        func_header_location((!empty($xcart_catalogs['admin']) ? $xcart_catalogs['admin'] : "$current_location/admin") . '/configuration.php?option=Paypal_Checkout');
    }
}

// uncomment for wizard feature and copy from /modules/Google_Ads_Kliken
//if (!is_callable('random_int')) {
//    require_once $xcart_dir . XC_DS . 'modules/Paypal_Checkout/lib/paragonie/random_compat/lib/random.php';
//}

class Tabs
{
    public static function generateData()
    {//{{{
        global $sql_tbl, $smarty, $xcart_dir, $config, $configuration;

        $paypal_checkout_integration_type_tabs = [];
        // admin

        if (empty($config['Paypal_Checkout']['paypal_checkout_account_id']) || empty($config['Paypal_Checkout']['paypal_checkout_account_token'])) {
            //$paypal_checkout_integration_type_tabs[] = static::generateGetStartedTab();
        } else {
            $paypal_checkout_integration_type_tabs[] = [
                'title'  => 'Manage Campaigns',
                'tpl'    => 'modules/Paypal_Checkout/backend/manage_campaigns.tpl',
                'anchor' => 'getstarted',
            ];
        }

        $paypal_checkout_integration_type_tabs[] = [
            'title'  => func_get_langvar_by_name('lbl_settings'),
            'tpl'    => 'modules/Paypal_Checkout/backend/setting_tab.tpl',
            'anchor' => 'payment-form',
        ];

        $paypal_checkout_integration_type_tabs[] = [
            'title'  => func_get_langvar_by_name('lbl_paypal_checkout_customize_button'),
            'tpl'    => 'modules/Paypal_Checkout/backend/paypal_checkout_customize_tab.tpl',
            'anchor' => 'customized-fields-form',
        ];
        $paypal_checkout_integration_type_tabs[] = [
            'title'  => func_get_langvar_by_name('lbl_paypal_checkout_credit_messaging'),
            'tpl'    => 'modules/Paypal_Checkout/backend/paypal_checkout_credit_messaging_tab.tpl',
            'anchor' => 'credit-messaging-fields',
        ];
        list($paypal_checkout_settings_form_fields, $paypal_checkout_customize_button_fields, $credit_messaging_fields) = func_paypal_checkout_filter_config($configuration);
        $smarty->assign('settings_form_fields', $paypal_checkout_settings_form_fields);
        $smarty->assign('customized_form_fields', $paypal_checkout_customize_button_fields);
        $smarty->assign('credit_messaging_fields', $credit_messaging_fields);

        // General part
        $smarty->assign('integration_type_tabs', $paypal_checkout_integration_type_tabs);
        $smarty->assign('custom_admin_module_config_tpl_file', 'modules/Paypal_Checkout/backend/configuration.tpl');

    }//}}}

    protected static function generateGetStartedTab()
    {//{{{
        global $smarty;
        $smarty->assign('paypal_checkout_signUpLink', Tools::getGetSignUpLink());

        return [
            'title'  => 'Get Started',
            'tpl'    => 'modules/Paypal_Checkout/backend/getstarted.tpl',
            'anchor' => 'getstarted',
        ];
    }//}}}
}

class Tools
{
    const BASE_PAYPAL_CHECKOUT_URL = 'https://x-cart.kliken.com';

    public static function getGetSignUpLink()
    {//{{{
        global $logged_userid, $current_location, $paypal_checkout_signin_token, $xcart_catalogs;

        // Get User info
        $userinfo = func_userinfo($logged_userid);

        // Generate a session Token for the bounce back data
        x_session_register('paypal_checkout_signin_token');
        if (empty($paypal_checkout_signin_token)) {
            $paypal_checkout_signin_token = self::generateKey();
        }

        return sprintf(
            self::BASE_PAYPAL_CHECKOUT_URL . '/auth/xcart/?u=%s&n=%s&e=%s&t=%s&return=%s',
            rawurlencode($current_location),
            rawurlencode($userinfo['firstname'] . " " . $userinfo['lastname']),
            rawurlencode($userinfo['email']),
            $paypal_checkout_signin_token,
            rawurlencode((!empty($xcart_catalogs['admin']) ? $xcart_catalogs['admin'] : "$current_location/admin") . '/configuration.php?option=Paypal_Checkout')
        );
    }//}}}

    public static function generateKey($length = 32, $keyspace = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ')
    {//{{{
        if (function_exists('func_get_secure_random_key')) {
            return func_get_secure_random_key($length, 'user_password');
        }

        if (function_exists('random_int')) {
            $pieces = [];
            $max    = mb_strlen($keyspace, '8bit') - 1;

            for ($i = 0; $i < $length; ++$i) {
                $pieces[] = $keyspace[random_int(0, $max)];
            }

            return implode('', $pieces);
        }

        return md5(uniqid(rand(), true));
    }//}}}
}

class CallbackHandler
{
    public static function savePaypalTokens_n_sendRestKeys($account_id, $application_token)
    {//{{{
        global $config;

        if (empty($account_id) || empty($application_token)) {
            return false;
        }
        func_array2update('config', ['value' => $account_id], "name = 'paypal_checkout_account_id'");
        func_array2update('config', ['value' => $application_token], "name = 'paypal_checkout_account_token'");
        $config['Paypal_Checkout']['paypal_checkout_account_id']    = $account_id;
        $config['Paypal_Checkout']['paypal_checkout_account_token'] = $application_token;

        if (static::postBackApiKeys()) {
            return true;
        } else {
            //TODO clear the above keys?
            return false;
        }
    }//}}}

    protected static function postBackApiKeys()
    {//{{{
        global $config, $current_location, $top_message;

        // Check if RESTAPI module has the keys saved or not
        $restKeyWrite = $config['Paypal_Checkout']['paypal_checkout_restkey_write'];
        $restKeyRead  = $config['Paypal_Checkout']['paypal_checkout_restkey_read'];

        if (empty($restKeyWrite)) {
            $restKeyWrite = Tools::generateKey();
            x_log_add('xc-paypal-checkout', 'REST API Write Key generated!');
            func_array2update('config', ['value' => $restKeyWrite], "name = 'paypal_checkout_restkey_write'");
        }

        if (empty($restKeyRead)) {
            $restKeyRead = Tools::generateKey();

            x_log_add('xc-paypal-checkout', 'REST API Read Key generated! ');
            func_array2update('config', ['value' => $restKeyRead], "name = 'paypal_checkout_restkey_read'");
        }

        // Send back to our Webhook the store URL, and the REST API keys. ONLY if we have account id and app Token.
        $accountId = $config['Paypal_Checkout']['paypal_checkout_account_id'];
        $appToken  = $config['Paypal_Checkout']['paypal_checkout_account_token'];

        if (!empty($accountId) && !empty($appToken)) {
            x_load('http');

            $hookUrl = 'v1/customer/partners/' . func_get_partner_id() . '/merchant-integrations/credentials';

            $body = json_encode([
                'account_id'     => $accountId,
                'app_token'      => $appToken,
                'store_url'      => $current_location,
                'rest_key_write' => $restKeyWrite,
                'rest_key_read'  => $restKeyRead,
            ]);
            list($a, $response) = func_https_request('POST', $hookUrl, $body, '', '', 'application / json', '', '', '');

            x_log_add('xc-paypal-checkout', 'POSTing to WW at: ' . $hookUrl . "response\n" . print_r($a, true) . print_r($response, true));

            if ($response === '0' || !preg_match("/HTTP\/.*\s*200\b/i", $a)) {
                x_session_register('top_message');
                $top_message = [
                    'type'    => 'W',
                    'content' => 'Module xc\Paypal_Checkout was unable to access your store . ',
                ];

                return false;
            }

            return true;
        }

        return false;
    }//}}}
}
