<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
 * +-----------------------------------------------------------------------------+
 * | X-Cart Software license agreement                                           |
 * | Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
 * | All rights reserved.                                                        |
 * +-----------------------------------------------------------------------------+
 * | PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
 * | FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
 * | AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
 * |                                                                             |
 * | THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
 * | SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
 * | (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
 * | FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
 * | THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
 * | LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
 * | INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
 * | (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
 * | LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
 * | NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
 * | PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
 * | THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
 * | SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
 * | GRANTED BY THIS AGREEMENT.                                                  |
 * +-----------------------------------------------------------------------------+
 * \*****************************************************************************/

/**
 * PayPal Checkout
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    $Id$
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if (!defined('XCART_START')) {
    header('Location: ../../');
    die('Access denied');
}

global $config, $XCART_SESSION_NAME, $xcart_dir, $sql_tbl, $CLIENT_IP, $smarty, $cc_processors_configuration_pages;

const XC_PAYPAL_CHECKOUT_CC          = 'cc_paypal_checkout.php';
const XC_PAYPAL_CHECKOUT_MODULE_NAME = 'Paypal_Checkout';

// https://developer.paypal.com/docs/api/payments/v2/#errors or https://developer.paypal.com/api/rest/reference/orders/v2/errors/#link-createorder
//define("XC_PAYPAL_CHECKOUT_NEGATIVE_TESTING", json_encode(['mock_application_codes' => 'INVALID_COUNTRY_CODE']));

$addons['Paypal_Checkout']      = true;
$css_files['Paypal_Checkout'][] = [];

$cc_processors_configuration_pages = empty($cc_processors_configuration_pages) ? [] : $cc_processors_configuration_pages;

$cc_processors_configuration_pages[XC_PAYPAL_CHECKOUT_CC] = 'configuration.php?option=Paypal_Checkout#paypal-tabs-payment-form';

if (!empty($include_func) || !empty($include_init)) {
    require_once "{$xcart_dir}/modules/Paypal_Checkout/func.php";

    func_paypal_checkout_init();
}
