{*
$Id$

vim: set ts=2 sw=2 sts=2 et:
*}

{capture name=paypal_query_params}
  '{$paypal_checkout_script}' +
  {if $main eq "checkout"}
    '&commit=true'
  {else}
    '&commit=false'
  {/if}
{*  + '&debug=true'*}
{/capture}

{capture name=paypal_script_params}
  {strip}
    {ldelim}
      'dataPartnerAttributionId':"{$config.paypal_checkout_bn_code|escape:"javascript"}"
      {if $paypal_checkout_client_token}
        ,'dataClientToken':"{$paypal_checkout_client_token|escape:"javascript"}"
      {/if}
    {rdelim}
  {/strip}
{/capture}

{capture name=paypal_javascript_code}
  (function (d, id, queryParams, scriptParams){literal} {

    let js, ref = d.getElementsByTagName('script')[0]
    if (!d.getElementById(id)) {
      js = d.createElement('script')
      js.id = id
      js.async = true

      js.onload = function () {
        const event_name = 'PayPal_lib_checkout_is_loaded'
        document.dispatchEvent(new CustomEvent(event_name));
        if (typeof $ !== 'undefined') {
          $('[data-paypal-button]').trigger(event_name)
        } else {

          let btns = document.querySelectorAll('[data-paypal-button]'), i

          if (btns) {
            const event = new Event(event_name)
            for (i = 0; i < btns.length; ++i) {
              if (btns[i]) {
                btns[i].dispatchEvent(event)
              }
            }
          }
        }
      }
      js.src = 'https://www.paypal.com/sdk/js?' + queryParams
      js.setAttribute('data-partner-attribution-id', scriptParams.dataPartnerAttributionId);
      js.setAttribute('data-client-token', scriptParams.dataClientToken);

      // js.setAttribute('debug', debug);
      // js.setAttribute('data-page-type', inDataPageType);

      ref.parentNode.insertBefore(js, ref)
    }

  }{/literal}(document, 'paypal-checkout-js',
    {$smarty.capture.paypal_query_params}, {*',' is mandatory*}
    {$smarty.capture.paypal_script_params}
  ));
{/capture}

{load_defer file="paypal_javascript_code" direct_info=$smarty.capture.paypal_javascript_code type="js" async=true}
